with Mcc.Parallel;
with Ada.Text_IO;

procedure Test_Portio is
begin
   Ada.Text_IO.Put_Line("Initialize LPT1");
   Mcc.Parallel.Initialize_Parallel_Port(1);

   for I in Mcc.Parallel.Writeable_Pin'range loop
      Mcc.Parallel.Set_Pin(
         Pin_Number => I,
         Value      => False);
   end loop;
   Ada.Text_IO.Put_Line("Set pins low");
   Ada.Text_IO.Skip_Line;
   
   Ada.Text_IO.Put_Line("Setting pins high");
   for I in Mcc.Parallel.Writeable_Pin'range loop
      Mcc.Parallel.Set_Pin(
         Pin_Number => I,
         Value      => True);
      Ada.Text_IO.Put_Line(Mcc.Parallel.Writeable_Pin'Image(I));
      Ada.Text_IO.Skip_Line;
   end loop;
   Ada.Text_IO.Put_Line("Done setting pins high-- press enter");
   Ada.Text_IO.Skip_Line;

   Ada.Text_IO.Put_Line("Setting pins low");
   for I in Mcc.Parallel.Writeable_Pin'range loop
      Mcc.Parallel.Set_Pin(
         Pin_Number => I,
         Value      => False);
      Ada.Text_IO.Put_Line(Mcc.Parallel.Writeable_Pin'Image(I));
      Ada.Text_IO.Skip_Line;
   end loop;
   Ada.Text_IO.Put_Line("Done setting pins low-- press enter");
   Ada.Text_IO.Skip_Line;

   Ada.Text_IO.Put_Line("Setting data pins high");
   Mcc.Parallel.Write_Data_Byte(255);
   Ada.Text_IO.Put_Line("Done setting pins high-- press enter");
   Ada.Text_IO.Skip_Line;

   Ada.Text_IO.Put_Line("Setting data pins low");
   Mcc.Parallel.Write_Data_Byte(0);
   Ada.Text_IO.Put_Line("Done setting pins-- press enter");
   Ada.Text_IO.Skip_Line;

   Ada.Text_IO.Put_Line("Setting control pins high");
   Mcc.Parallel.Write_Control_Nibble(15);
   Ada.Text_IO.Put_Line("Done setting pins-- press enter");
   Ada.Text_IO.Skip_Line;

   Ada.Text_IO.Put_Line("Setting control pins low");
   Mcc.Parallel.Write_Control_Nibble(0);
   Ada.Text_IO.Put_Line("Done setting pins-- press enter");
   Ada.Text_IO.Skip_Line;

   declare
      Pin_Value      : Boolean;
      Control_Nibble : Mcc.Parallel.Nibble;
      Data_Nibble    : Mcc.Parallel.Nibble;
   begin
      for i in Mcc.Parallel.Readable_Pin'range loop
         if not Mcc.Parallel.Is_Control_Pin(i) then
            Mcc.Parallel.Read_Pin(
               Pin_Number => i,
               Value      => Pin_Value);
            Ada.Text_IO.Put_Line(
               "Value of " &
               Mcc.Parallel.Readable_Pin'Image(I) &
               " is " & Boolean'Image(Pin_Value));
         end if;
      end loop;

      Mcc.Parallel.Read_Data_Nibble(Data_Nibble);
      Mcc.Parallel.Make_Control_Pins_Read;
      Mcc.Parallel.Read_Control_Nibble(Control_Nibble);

      Ada.Text_IO.Put_Line(
         "Data Nibble is" & Mcc.Parallel.Nibble'Image(Data_Nibble));
      Ada.Text_IO.Put_Line(
         "Control Nibble is" & Mcc.Parallel.Nibble'Image(Control_Nibble));
   end;

    Mcc.Parallel.Unload_Parallel_Port;

end Test_Portio;